datablock ItemData(R_MW92fsItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/92fs/92fsMW.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Handgun Modern";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = R_MW92fsImage;
	canDrop = true;
};

$RWep_MagazineMax["MW92FS"] = 3;
$RWep_MagazineName["MW92FS"] = "Handgun92FSExt";
datablock ShapeBaseImageData(R_MW92fsImage)
{
	R_Reloadable = true;
	R_ADSImage = R_MW92fsAimingImage;
	R_ReloadImage = R_MW92fsReloadingImage;
	R_MagSize = 30;
	R_AmmoName = "MW92FS";
	R_AmmoType = "Low Power";
	R_InheritImage = R_MW92fsImage;
	R_UsesMagazines = true;
	
	R_FarShotSound = RDistSound_Pistol;

   shapeFile = "./shapes/92fs/92fsMW.dts";
   
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = R_SubmachineGunProjectile;
   projectileType = Projectile;

	casing 				= R_SubmachineGunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_MW92fsItem.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]				= "Battery";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]					= "Battery";
	stateScript[1]					= "onReady";
	//stateTransitionOnNoAmmo[1]		= "PreAmmoCheck";

	// FIRE ONE
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.04;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "BurstFire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[2]				= 0.03;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= R_PistolShotSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= R_SubmachineGunSmokeEmitter;
	stateEmitterTime[3]				= 0.2;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.000;
	stateTransitionOnTimeout[3]     = "PreAmmoCheck2";

	stateName[8]					= "PreAmmoCheck2";
	stateScript[8]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[8]		= "AmmoCheck2";
	stateTimeoutValue[8]            = 0.01;
	
	stateName[9]					= "AmmoCheck2";
	stateTransitionOnAmmo[9]		= "Fire2";
	stateTransitionOnNoAmmo[9]		= "Dryfire";
	
	// FIRE TWO
	stateName[10]                    = "Fire2";
	stateTransitionOnTimeout[10]     = "PreAmmoCheck3";
	stateTimeoutValue[10]            = 0.04;
	stateFire[10]                    = true;
	stateAllowImageChange[10]        = false;
	stateSequence[10]                = "BurstFire";
	stateScript[10]                  = "onFire";
	stateWaitForTimeout[10]			= true;
	stateEmitter[10]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[10]				= 0.03;
	stateEmitterNode[10]				= "muzzleNode";
	stateSound[10]					= R_PistolShotSound;
	stateEjectShell[10]       = true;
	
	stateName[11]					= "PreAmmoCheck3";
	stateScript[11]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[11]		= "AmmoCheck3";
	stateTimeoutValue[11]            = 0.01;
	
	stateName[12]					= "AmmoCheck3";
	stateTransitionOnAmmo[12]		= "Fire3";
	stateTransitionOnNoAmmo[12]		= "Dryfire";


	// FIRE THREE
	stateName[13]                    = "Fire3";
	stateTransitionOnTimeout[13]     = "Wait";
	stateTimeoutValue[13]            = 0.25;
	stateFire[13]                    = true;
	stateAllowImageChange[13]        = false;
	stateSequence[13]                = "Fire";
	stateScript[13]                  = "onFire";
	stateWaitForTimeout[13]			= true;
	stateEmitter[13]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[13]				= 0.03;
	stateEmitterNode[13]				= "muzzleNode";
	stateSound[13]					= R_PistolShotSound;
	stateEjectShell[13]       = true;

	// DONE
	stateName[14]                    = "Wait";
	stateTransitionOnTimeout[14] 	 = "Reload";
	stateTimeoutValue[14]			 = 0.15;
	
	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	stateTransitionOnTriggerDown[4]   = "PreAmmoCheck";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;
	
	grace = 3;
	rBurstStartIndex = 2;
	rBurstSpreadY = 0.024;

};
datablock ShapeBaseImageData(R_MW92fsAimingImage : R_MW92fsImage)
{
	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) ); 
	eyeOffset = "0.0 0.8 -0.427964";
	R_ADSImage = R_MW92fsImage;
	
	spreadCoef = 5;
	grace = 3;
	rBurstStartIndex = 2;
	rBurstSpreadY = 0.012;
	
	forceZoomFOV = $IronsightsFov;
	R_MovePenalty = $IronsightsMovePenalty;
};
// datablock ShapeBaseImageData(R_MW92fsReloadingPlusOneImage)
// {
	// R_InheritImage = R_MW92fsImage;
	// shapeFile = "./shapes/92fs/92fsMW.dts";
   // emap = true;
   // mountPoint = 0;
   // offset = "0 0 0";
   // eyeOffset = 0; //"0.7 1.2 -0.5";
   // rotation = eulerToMatrix( "0 0 0" ); 
   // correctMuzzleVector = true;
   // className = "WeaponImage";
   // item = BowItem;
   // ammo = " ";
   // projectile = R_SubmachineGunProjectile;
   // projectileType = Projectile;

	// casing = R_PistolMagDebris;
	// shellExitDir        = "0.0 0.0 -1.0";
	// shellExitOffset     = "0 0 0";
	// shellExitVariance   = 15.0;	
	// shellVelocity       = 7.0;
	
   // melee = false;
   // armReady = true;

   // doColorShift = true;
   // colorShiftColor = R_MW92fsItem.colorShiftColor;//"0.400 0.196 0 1.000";

	// stateName[0]                    = "ReloadStart";
	// stateTransitionOnTimeout[0]		= "MagOut";
	// stateTimeoutValue[0]			= 0.15;
	// stateSequence[0]				= "battery";
	
	// stateName[1]                    = "MagOut";
	// stateTransitionOnTimeout[1]		= "MagIn";
	// stateEjectShell[1]       		= true;
	// stateSequence[1]				= "noMag";
	// stateScript[1]					= "onMagOut";
	// stateTimeoutValue[1]			= 0.35;
	// stateSound[1]					= R_SubmachineReload1Sound;
	
	// stateName[2]                    = "MagIn";
	// stateTransitionOnTimeout[2]		= "finish";
	// stateSequence[2]				= "battery";
	// stateScript[2]					= "onMagIn";
	// stateTimeoutValue[2]			= 0.55;
	// stateSound[2]					= R_SubmachineReload2Sound;

	// stateName[4]                    = "Finish";
	// stateScript[4]					= "onReloadFinish";
// };
datablock ShapeBaseImageData(R_MW92fsReloadingImage)
{
	R_InheritImage = R_MW92fsImage;
	shapeFile = "./shapes/92fs/92fsMW.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" ); 
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = R_SubmachineGunProjectile;
   projectileType = Projectile;

	casing = R_PistolMagDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_MW92fsItem.colorShiftColor;//"0.400 0.196 0 1.000";

	reloadTime0 = 1.45;
	reloadTime1 = 1.15;

	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.15;
	stateSequence[0]				= "battery";
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;
	stateSequence[1]				= "noMag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 0.35;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "battery";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.55;
	stateSound[2]					= R_SubmachineReload2Sound;

	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateSequence[3]				= "rack";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.3;
	stateSound[3]					= R_SubmachineReload3Sound;

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};

// function R_MW92fsReloadingImage::onMount(%this, %player, %slot)
// {
	// if(%player.R_Ammo["92FS"] > 0)
	// {
		// %player.mountImage(R_MW92fsReloadingPlusOneImage, 0);
	// }
	// Parent::onMount(%this, %player, %slot);
// }

function R_MW92fsImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}
function R_MW92fsAimingImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}

function R_MW92fsReloadingImage::onMagOut(%this, %player, %slot){%player.playThread(2, shiftAway);}
function R_MW92fsReloadingImage::onMagIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_MW92fsReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, plant);}
function R_MW92fsReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}
function R_MW92fsReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}

// function R_MW92fsReloadingPlusOneImage::onMagOut(%this, %player, %slot){R_MW92fsReloadingImage::onMagOut(%this, %player, %slot);}
// function R_MW92fsReloadingPlusOneImage::onMagIn(%this, %player, %slot){R_MW92fsReloadingImage::onMagIn(%this, %player, %slot);}
// function R_MW92fsReloadingPlusOneImage::onReloadFinish(%this, %player, %slot){R_MW92fsReloadingImage::onReloadFinish(%this, %player, %slot);}

function R_MW92fsImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_MW92fsAimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}

function R_MW92fsImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_MW92fsAimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
