datablock ItemData(R_92fsItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/92fs/92fs.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Handgun Police";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = R_92fsImage;
	canDrop = true;
};

$RWep_MagazineMax["92FS"] = 3;
$RWep_MagazineName["92FS"] = "Handgun92FS";
datablock ShapeBaseImageData(R_92fsImage)
{
	R_Reloadable = true;
	R_ADSImage = R_92fsAimingImage;
	R_ReloadImage = R_92fsReloadingImage;
	R_MagSize = 17;
	R_AmmoName = "92FS";
	R_AmmoType = "Low Power";
	R_InheritImage = R_92fsImage;
	R_UsesMagazines = true;
	
	R_FarShotSound = RDistSound_Pistol;

   shapeFile = "./shapes/92fs/92fs.dts";
   
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );
   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = R_SubmachineGunProjectile;
   projectileType = Projectile;

	casing 				= R_SubmachineGunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_92fsItem.colorShiftColor;

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSequence[0]				 = "battery";
	stateSound[0]					 = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]				 = "Ready";
	stateScript[1]					 = "onReady";
	stateTransitionOnNoAmmo[1]		 = "PreAmmoCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.12;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= R_PistolShotSound;
	stateEjectShell[2]       		= true;

	stateName[3] 				    = "Smoke";
	stateEmitter[3]					= R_SubmachineGunSmokeEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.00;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;

};
datablock ShapeBaseImageData(R_92fsAimingImage : R_92fsImage)
{
	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) ); 
	eyeOffset = "0.0 0.8 -0.427964";
	R_ADSImage = R_92fsImage;
	
	spreadCoef = 5;
	forceZoomFOV = $IronsightsFov;
	R_MovePenalty = $IronsightsMovePenalty;
};
datablock ShapeBaseImageData(R_92fsReloadingImage)
{
	R_InheritImage = R_92fsImage;
	shapeFile = "./shapes/92fs/92fs.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" ); 
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = BowItem;
   ammo = " ";
   projectile = R_SubmachineGunProjectile;
   projectileType = Projectile;

	casing = R_PistolMagDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_92fsItem.colorShiftColor;//"0.400 0.196 0 1.000";

	reloadTime0 = 1.45;
	reloadTime1 = 1.15;
	
	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.15;
	stateSequence[0]				= "battery";
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;
	stateSequence[1]				= "noMag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 0.35;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "battery";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.55;
	stateSound[2]					= R_SubmachineReload2Sound;

	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateSequence[3]				= "rack";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.3;
	stateSound[3]					= R_SubmachineReload3Sound;

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};

function R_92fsImage::onFire(%this, %player, %slot){RWep_handleWeaponFire(%this, %player, %slot);}
function R_92fsAimingImage::onFire(%this, %player, %slot){RWep_handleWeaponFire(%this, %player, %slot);}

function R_92fsReloadingImage::onMagOut(%this, %player, %slot){%player.playThread(2, shiftAway);}
function R_92fsReloadingImage::onMagIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_92fsReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, plant);}
function R_92fsReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}
function R_92fsReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}

function R_92fsImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_92fsAimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}

function R_92fsImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_92fsAimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}