$RWepARSh = "./shapes/arifle/AR_1550.dts";

datablock AudioProfile(R_1550RifleShotSound)
{
   filename    = "./sounds/rifle_1550.wav";
   description = AudioDefault3d;
   preload = true;
   
   randomPitch = 10; 			// Random amount of pitch when fired
   pitchIncreasePerShot = 0.4;  // Increase in pitch as we get to the end of magazine
};

datablock ProjectileData(R_1550RifleProjectile : R_SubmachineGunProjectile)
{
	directDamage        = 75;
	muzzleVelocity      = 200;
	velInheritFactor    = 0;

	isBallistic         = true;
	gravityMod 			= 0.5;

	// Damage Falloff
	// https://www.desmos.com/calculator/bntmotjfi7
	DamageFalloffEffective = 128;	// How far a bullet can travel before damage begins to drop
	DamageFalloffRange = 256;		// Over what further distance damage drops to 0 (note: damage is clamped, see $MinimumDamageFalloff)
	DamageFalloffDelta = 2;			// Falloff coef, 1 is linear, higher numbers have a sharper bend

	allowRicochet		= false;		// s.e.

	// How much wall in torque units this bullet can penetrate. Note: 0.5tu = 1 brick. 
	// Give it some wiggle room (~0.25tu) since bullets rarely hit at a perfect angle.
	wallPenetrationAmount = 1.75;

	// Armor level this bullet is effective against
	threatLevel = 4;
};


datablock ItemData(R_1550RifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = $RWepARSh;
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Assault Rifle Heavy";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = $GlobalColorShift;

	image = R_1550RifleImage;
	canDrop = true;
};

$RWep_MagazineMax["AR1550"] = 2;
datablock ShapeBaseImageData(R_1550RifleImage)
{
	R_MagSize = 10;
	R_AmmoName = "AR1550";
	R_AmmoType = "High Power";
	R_ADSImage = R_1550RifleAimingImage;
	R_ReloadImage = R_1550RifleReloadingImage;
	R_TriggerReleasePenalty = false;
	R_UsesMagazines = true;
	R_InheritImage = R_1550RifleImage;
	
	R_FarShotSound = RDistSound_AssaultRifle;
	R_WeaponFireSound = R_1550RifleShotSound;
	
	sprayseed = 389041;
	
	shapeFile = $RWepARSh;
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;
	className = "WeaponImage";

	item = R_1550RifleItem;
	ammo = " ";
	projectile = R_1550RifleProjectile;
	projectileType = Projectile;

	casing = R_PKMShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = R_1550RifleItem.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]				= "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]					= "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnNoAmmo[1]		= "PreAmmoCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.3;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_ShotgunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= "";
	stateEjectShell[2]       		= true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= R_ShotgunSmokeEmitter;
	stateEmitterTime[3]				= 0.02;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.000;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	//stateTransitionOnTriggerDown[4]   = "PreAmmoCheck";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;
	
	
	

	recoilAnimationPoint = 0;	// 	- How many bullets must be fired before the gun begins to recoil visually, has no effect on accuracy
	grace = 1;					//	- How many bullets must be fired before the gun begins to recoil
	screenShake = true;			//	- Self explanatory
	screenShakeModifier = 0.1;	//	- Self explanatory
	screenShakeMin = 0.8;		//	- Self explanatory
	screenShakeMax = 1.2;		//	- Self explanatory
	resetTime = 512;			//	- How long (ms) the gun has to be idle/not shooting before recoil resets
	climbModifier = 0.8;		//	- Intensity of vertical recoil
	boundModifier = 0.2;		//	- Intensity of horizontal recoil
	
};
datablock ShapeBaseImageData(R_1550RifleAimingImage : R_1550RifleImage)
{
	eyeOffset = "0.0 0.5 -0.702722";

	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) );

	R_ADSImage = R_1550RifleImage;
	
	climbModifier 	= $IronsightsDefaultClimbMod * 2;
	boundModifier 	= $IronsightsDefaultBoundMod * 2;
	forceZoomFOV 	= 40;
	R_MovePenalty 	= $ScopedMovePenalty;
	
	rVectorAdjustY = 0.006;
};

//// Reloading
datablock ShapeBaseImageData(R_1550RifleReloadingImage)
{
	// Define this, it's important!
	R_InheritImage = R_1550RifleImage;

	shapeFile = $RWepARSh;
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" ); 
	correctMuzzleVector = true;
	className = "WeaponImage";
	item = R_1550RifleItem;
	ammo = " ";
	projectile = R_SubmachineGunProjectile;
	projectileType = Projectile;
	melee = false;
	armReady = true;
	doColorShift = true;
	colorShiftColor = R_1550RifleItem.colorShiftColor;

	// Use magazine debris here
	casing = R_AssaultRifleMagDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

						// Required for reload timer
	reloadTime0 = 2.61;	// How long it takes to reload when there is no ammo in the magazine
	reloadTime1 = 2.36;	// How long it takes to reload when there is ammo in the magazine

	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.01;
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;	// Eject magazine
	stateSequence[1]				= "noMag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 2.00;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "Ready";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.25;
	stateSound[2]					= R_SubmachineReload2Sound;
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.25;
	stateSound[3]					= R_SubmachineReload3Sound;
	stateSequence[3]				= "charge";

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};

// Shared functions
// Fire
function R_1550RifleImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}
function R_1550RifleAimingImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}

// Ammo check
function R_1550RifleImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_1550RifleAimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}

// Dry fire
function R_1550RifleImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_1550RifleAimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}

// Reloading
function R_1550RifleReloadingImage::onMagOut(%this, %player, %slot){%player.playThread(2, plant);}
function R_1550RifleReloadingImage::onMagIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_1550RifleReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, shiftLeft);}

function R_1550RifleReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}
function R_1550RifleReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}