datablock AudioProfile(R_BRSOPMODSoundTail)
{
   filename    = "./sounds/silenced_fal_tail.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(R_BRSOPMODSoundLoop)
{
   filename    = "./sounds/silenced_fal_loop.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   
   tailDB = R_BRSOPMODSoundTail;
};

datablock ItemData(R_BattleRifleSOPMODItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/arifle/BRSOPMODItem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Battle Rifle SOPMOD";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = R_BattleRifleSOPMODImage;
	canDrop = true;
};


$RWep_MagazineMax["BattleRifleSOPMOD"] = 3;
datablock ShapeBaseImageData(R_BattleRifleSOPMODImage)
{
	R_Reloadable = true;
	R_MagSize = 20;
	R_AmmoName = "BattleRifleSOPMOD";
	R_AmmoType = "High Power";
	R_ADSImage = R_BattleRifleSOPMODScopeImage;
	R_ReloadImage = R_BattleRifleSOPMODReloadingImage;
	R_TriggerReleasePenalty = true;
	
	R_InheritImage = R_BattleRifleSOPMODImage;
	R_UsesMagazines = true;
	
	R_FarShotSound = RDistSound_BattleRifle;
	R_WeaponLoopSound = R_BRSOPMODSoundLoop;
	R_DoLaserSightCorrection = true;
	
	spraySeed = 601257;

	shapeFile = "./shapes/arifle/BRSOPMOD.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "-1 0 1.5" );
	correctMuzzleVector = true;
	className = "WeaponImage";

	item = R_BattleRifleSOPMODItem;
	ammo = " ";
	projectile = R_BattleRifleProjectile;
	projectileType = Projectile;

	casing = R_BattleRifleShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = R_BattleRifleSOPMODItem.colorShiftColor; //R_BattleRifleSOPMODItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]				= "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]					= "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnNoAmmo[1]		= "PreAmmoCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_TacRifleFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= "";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= R_ShotgunSmokeEmitter;
	stateEmitterTime[3]				= 0.01;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.000;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	stateTransitionOnTriggerDown[4]	= "PreAmmoCheck";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;
	
	grace = 3;
	
	resetTime 		= 256;
	
	climbModifier 	= 0.65;
	boundModifier 	= 0.4;
	
	screenShakeMax = 0.45;
	screenShakeModifier = 0.35;
	
	recoilAnimationPoint = 4;
};
datablock ShapeBaseImageData(R_BattleRifleSOPMODScopeImage : R_BattleRifleSOPMODImage)
{
	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) ); 
	eyeOffset = "0.0 0.3 -0.636531";
	R_ADSImage = R_BattleRifleSOPMODCantedImage;
	
	grace = 3;
	
	climbModifier = $IronsightsDefaultClimbMod;
	boundModifier = $IronsightsDefaultBoundMod;
	forceZoomFOV = 40;
	R_MovePenalty = $ScopedMovePenalty;
};
datablock ShapeBaseImageData(R_BattleRifleSOPMODCantedImage : R_BattleRifleSOPMODImage)
{
	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) ); 
	eyeRotation = 0;
	eyeOffset = "0.0 0.3 -0.826313";
	R_ADSImage = R_BattleRifleSOPMODImage;
	
	grace = 3;
	
	climbModifier = $IronsightsDefaultClimbMod;
	boundModifier = $IronsightsDefaultBoundMod;
	forceZoomFOV = $IronsightsFov;
	R_MovePenalty = $IronsightsMovePenalty;
};


// Reload group
datablock ShapeBaseImageData(R_BattleRifleSOPMODReloadingImage)
{
	R_InheritImage = R_BattleRifleSOPMODImage;
	shapeFile = "./shapes/arifle/BRSOPMOD.dts";
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" ); 
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = R_BattleRifleSOPMODItem;
   ammo = " ";
   projectile = R_SubmachineGunProjectile;
   projectileType = Projectile;

	casing = R_BattleRifleMagDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_BattleRifleSOPMODItem.colorShiftColor;//"0.400 0.196 0 1.000";

	reloadTime1 = 1.36;
	reloadTime0 = 1.61;

	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.01;
	stateSequence[0]				= "Ready";
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;
	stateSequence[1]				= "noMag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 1.00;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "Ready";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.25;
	stateSound[2]					= R_SubmachineReload2Sound;
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.25;
	stateSound[3]					= R_SubmachineReload3Sound;
	stateSequence[3]				= "charge";

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};

// Fire group
function R_BattleRifleSOPMODImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}																
function R_BattleRifleSOPMODScopeImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}
function R_BattleRifleSOPMODCantedImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}

// Ammo check group
function R_BattleRifleSOPMODImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_BattleRifleSOPMODScopeImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_BattleRifleSOPMODCantedImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}

function R_BattleRifleSOPMODReloadingImage::onMagOut(%this, %player, %slot){%player.playThread(2, plant);}
function R_BattleRifleSOPMODReloadingImage::onMagIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_BattleRifleSOPMODReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, shiftLeft);}
function R_BattleRifleSOPMODReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}
function R_BattleRifleSOPMODReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}

function R_BattleRifleSOPMODImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_BattleRifleSOPMODScopeImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_BattleRifleSOPMODCantedImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}