$RWepARSh = "./shapes/arifle/AR_Civilian.dts";

datablock ItemData(R_CivilianRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	shapeFile = $RWepARSh;
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Militia Rifle";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = $GlobalColorShift;

	image = R_CivilianRifleImage;
	canDrop = true;
};

datablock ShapeBaseImageData(R_CivilianRifleImage)
{
	R_MagSize = 30;
	R_AmmoName = "ARCivilian";
	R_AmmoType = "Medium Power";
	R_ADSImage = R_CivilianRifleAimingImage;
	R_ReloadImage = R_CivilianRifleReloadingImage;
	R_TriggerReleasePenalty = false;
	R_UsesMagazines = true;	
	R_SharedMagazine = "NATO";
	R_InheritImage = R_CivilianRifleImage;
	
	R_FarShotSound = RDistSound_AssaultRifle;
	R_WeaponFireSound = R_AssaultRifleShotSound;
	
	sprayseed = 433987;
	
	shapeFile = $RWepARSh;
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;
	className = "WeaponImage";

	item = R_CivilianRifleItem;
	ammo = " ";
	projectile = R_AssaultRifleProjectile;
	projectileType = Projectile;

	casing = R_AssaultRifleShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = R_CivilianRifleItem.colorShiftColor;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]				= "MagIn";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]					= "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnNoAmmo[1]		= "PreAmmoCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.08;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= "";
	stateEjectShell[2]       		= true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= R_SubmachineGunSmokeEmitter;
	stateEmitterTime[3]				= 0.2;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.000;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	//stateTransitionOnTriggerDown[4]   = "PreAmmoCheck";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;
	
	
	

	recoilAnimationPoint = 100;	// 	- How many bullets must be fired before the gun begins to recoil visually, has no effect on accuracy
	grace = 1;					//	- How many bullets must be fired before the gun begins to recoil
	// screenShake = true;			//	- Self explanatory
	// screenShakeModifier = 0.05;	//	- Self explanatory
	// screenShakeMin = 0.10;		//	- Self explanatory
	// screenShakeMax = 0.35;		//	- Self explanatory
	resetTime = 256;				//	- How long (ms) the gun has to be idle/not shooting before recoil resets
	climbModifier = 0.1;		//	- Intensity of vertical recoil
	boundModifier = 0.01;		//	- Intensity of horizontal recoil
	
};
datablock ShapeBaseImageData(R_CivilianRifleAimingImage : R_CivilianRifleImage)
{
	eyeOffset = "0.0 0.5 -0.630405";

	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) );

	R_ADSImage = R_CivilianRifleImage;
	
	resetTime = 128;
	climbModifier 	= $IronsightsDefaultClimbMod;
	boundModifier 	= $IronsightsDefaultBoundMod;
	forceZoomFOV 	= $IronsightsFov;
	R_MovePenalty 	= $IronsightsMovePenalty;
	
	rVectorAdjustY = 0.005;
};

//// Reloading
datablock ShapeBaseImageData(R_CivilianRifleReloadingImage)
{
	// Define this, it's important!
	R_InheritImage = R_CivilianRifleImage;

	shapeFile = $RWepARSh;
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" ); 
	correctMuzzleVector = true;
	className = "WeaponImage";
	item = R_CivilianRifleItem;
	ammo = " ";
	projectile = R_SubmachineGunProjectile;
	projectileType = Projectile;
	melee = false;
	armReady = true;
	doColorShift = true;
	colorShiftColor = R_CivilianRifleItem.colorShiftColor;

	// Use magazine debris here
	casing = R_AssaultRifleMagDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

						// Required for reload timer
	reloadTime0 = 1.61;	// How long it takes to reload when there is no ammo in the magazine
	reloadTime1 = 1.36;	// How long it takes to reload when there is ammo in the magazine

	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.01;
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;	// Eject magazine
	stateSequence[1]				= "noMag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 1.00;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "Ready";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.25;
	stateSound[2]					= R_SubmachineReload2Sound;
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.25;
	stateSound[3]					= R_SubmachineReload3Sound;
	stateSequence[3]				= "charge";

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};

// Shared functions
// Fire
function R_CivilianRifleImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}
function R_CivilianRifleAimingImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}

// Ammo check
function R_CivilianRifleImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_CivilianRifleAimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}

// Dry fire
function R_CivilianRifleImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_CivilianRifleAimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}

// Reloading
function R_CivilianRifleReloadingImage::onMagOut(%this, %player, %slot){%player.playThread(2, plant);}
function R_CivilianRifleReloadingImage::onMagIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_CivilianRifleReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, shiftLeft);}

function R_CivilianRifleReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}
function R_CivilianRifleReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}