$RWepARSh = "./shapes/ak47/SBR.dts";
datablock AudioProfile(R_AKSBRRifleSoundLoop)
{
   filename    = "./sounds/rifle_ak47su_loop.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   
   tailDB = R_AKRifleSoundTail;
};

datablock ItemData(R_SBRifleFORItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = $RWepARSh;
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Assault Rifle SBROP";
	iconName = "./icon_gun";
	doColorShift = true;
	colorShiftColor = $GlobalColorShift;

	 // Dynamic properties defined by the scripts
	image = R_SBRifleFORImage;
	canDrop = true;
};

datablock ShapeBaseImageData(R_SBRifleFORImage)
{
	R_Reloadable = true;
	R_MagSize = 30;
	R_AmmoName = "ARSBRFOR";
	R_AmmoType = "Medium Power";
	R_ADSImage = R_SBRifleFORAimingImage;
	R_ReloadImage = R_SBRifleFORReloadingImage;
	R_TriggerReleasePenalty = true;
	R_UsesMagazines = true;
	R_SharedMagazine = "Soviet";
	R_InheritImage = R_SBRifleFORImage;
	
	R_FarShotSound = RDistSound_AssaultRifle;
	R_WeaponLoopSound = R_AKSBRRifleSoundLoop;
	
	spraySeed = 404233;

	shapeFile = $RWepARSh;
	emap = true;
	mountPoint = 0;
	offset = "0 0 0";
	eyeOffset = 0; //"0.7 1.2 -0.5";
	rotation = eulerToMatrix( "0 0 0" );
	correctMuzzleVector = true;
	className = "WeaponImage";

	item = R_SBRifleFORItem;
	ammo = " ";
	projectile = R_AKRifleProjectile;
	projectileType = Projectile;

	casing = R_AssaultRifleShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	melee = false;
	armReady = true;

	doColorShift = true;
	colorShiftColor = R_SBRifleFORItem.colorShiftColor;//"0.400 0.196 0 1.000";

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSequence[0]				= "MagIn";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreAmmoCheck";
	stateAllowImageChange[1]         = true;
	stateSequence[1]					= "Ready";
	stateScript[1]					= "onReady";
	stateTransitionOnNoAmmo[1]		= "PreAmmoCheck";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.06;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= R_SubmachineGunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= "";
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= R_SubmachineGunSmokeEmitter;
	stateEmitterTime[3]				= 0.2;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.000;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]					= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]   = "Ready";
	stateTransitionOnTriggerDown[4]   = "PreAmmoCheck";
	stateSequence[4]				= "Ready";
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Fire";
	stateTransitionOnNoAmmo[6]		= "Dryfire";
	
	stateName[7]					= "Dryfire";
	stateScript[7]					= "onDryFire";
	stateTransitionOnTriggerUp[7]	= "Ready";
	stateTimeoutValue[7]			= 0.1;
	
	grace = 1;
	recoilAnimationPoint = 2;
	climbModifier = 0.75;
	boundModifier = 0.5;
};
datablock ShapeBaseImageData(R_SBRifleFORAimingImage : R_SBRifleFORImage)
{
	rotation = eulerToMatrix( vectorAdd( "0 0 0", $Pref::RallyPack::ADSRollVector ) ); 
	shapeFile = "./shapes/ak47/SBRads.dts";
	R_InheritImage = R_SBRifleFORImage;
	
	eyeOffset = "0.0 0.3 -0.547193";
	R_ADSImage = R_SBRifleFORImage;
	
	climbModifier = $IronsightsDefaultClimbMod;
	boundModifier = $IronsightsDefaultBoundMod;
	
	forceZoomFOV = $IronsightsFov;
	R_MovePenalty = $IronsightsMovePenalty;
};

//// Reloading
datablock ShapeBaseImageData(R_SBRifleFORReloadingImage)
{
	R_InheritImage = R_SBRifleFORImage;

   shapeFile = $RWepARSh;
   emap = true;
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" ); 
   correctMuzzleVector = true;
   className = "WeaponImage";
   item = R_SBRifleFORItem;
   ammo = " ";
   projectile = R_SubmachineGunProjectile;
   projectileType = Projectile;

	casing = R_AKRifleMagDebris;
	shellExitDir        = "0.0 0.0 -1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;
	
   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = R_SBRifleFORItem.colorShiftColor;//"0.400 0.196 0 1.000";

	reloadTime1 = 1.36;
	reloadTime0 = 1.61;

	stateName[0]                    = "ReloadStart";
	stateTransitionOnTimeout[0]		= "MagOut";
	stateTimeoutValue[0]			= 0.01;
	
	stateName[1]                    = "MagOut";
	stateTransitionOnTimeout[1]		= "MagIn";
	stateEjectShell[1]       		= true;
	stateSequence[1]				= "noMag";
	stateScript[1]					= "onMagOut";
	stateTimeoutValue[1]			= 1.00;
	stateSound[1]					= R_SubmachineReload1Sound;
	
	stateName[2]                    = "MagIn";
	stateTransitionOnTimeout[2]		= "PreAmmoCheck";
	stateSequence[2]				= "Ready";
	stateScript[2]					= "onMagIn";
	stateTimeoutValue[2]			= 0.25;
	stateSound[2]					= R_SubmachineReload2Sound;
	
	stateName[5]					= "PreAmmoCheck";
	stateScript[5]					= "onPreAmmoCheck";
	stateTransitionOnTimeout[5]		= "AmmoCheck";
	stateTimeoutValue[5]			= 0.1;
	
	stateName[6]					= "AmmoCheck";
	stateTransitionOnAmmo[6]		= "Finish";
	stateTransitionOnNoAmmo[6]		= "Charge";	

	stateName[3]                    = "Charge";
	stateTransitionOnTimeout[3]		= "Finish";
	stateScript[3]					= "onCharge";
	stateTimeoutValue[3]			= 0.25;
	stateSound[3]					= R_SubmachineReload3Sound;
	stateSequence[3]				= "charge";

	stateName[4]                    = "Finish";
	stateScript[4]					= "onReloadFinish";
};

// Fire
function R_SBRifleFORImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}
function R_SBRifleFORAimingImage::onFire(%this, %player, %slot){RWepSim_handleWeaponFire(%this, %player, %slot);}

// Ammo check
function R_SBRifleFORImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}
function R_SBRifleFORAimingImage::onPreAmmoCheck(%this, %player, %slot){RWep_preAmmoCheck(%this, %player, %slot);}

// Dry fire
function R_SBRifleFORImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}
function R_SBRifleFORAimingImage::onDryFire(%this, %player, %slot){RWep_DryFire(%this, %player, %slot);}

// Reloading
function R_SBRifleFORReloadingImage::onMagOut(%this, %player, %slot){%player.playThread(2, plant);}
function R_SBRifleFORReloadingImage::onMagIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function R_SBRifleFORReloadingImage::onCharge(%this, %player, %slot){%player.playThread(2, shiftLeft);}

function R_SBRifleFORReloadingImage::onReloadFinish(%this, %player, %slot){RWepMagazine_handleReload(%this, %player, %slot);}
function R_SBRifleFORReloadingImage::onPreAmmoCheck(%this, %player, %slot){RWep_reloadingAmmoCheck(%this, %player, %slot);}